﻿
//*** crearArrayPosicionsElements => invocat per 'stage' ***
//recull els valors dels arrays 'posX_elements' i 'posY_elements'
//inicialitza 'posXY_elements', on cada posició guarda un string corresponent a un parell x,y
function crearArrayPosicionsElements(array_X: Array, array_Y: Array): Array {
	var posXY_elements = new Array();
	var currentPos: int = 0;
	for (var i: int = 0; i < array_X.length; i++) {
		for (var j: int = 0; j < array_Y.length; j++) {
			posXY_elements[currentPos] = String(array_X[i]) + ',' + String(array_Y[j]);
			currentPos++;
		}
	}
	return posXY_elements;
}

//*** triarIdentificadors() => invocat per 'stage'
//inicialitza l'array 'arrayElementsTriats', on cada posició guarda un dels elements triat per al joc.
//totes les funcions de renderització de la vista depenen directament o indirecta d'aquestes dades
function triarIdentificadors(): void {
	for (var i: int = 0; i < numIdentificadors; i++) {
		var rnd: int = Math.floor(Math.random() * arrayElements.length);

		arrayElementsTriats.push(arrayElements[rnd]);

		arrayElements.removeAt(rnd);

	}
};

//*** instanciarElements() => invocat per 'mostrarElements()' ***
function instanciarElements(element: MovieClip, nom: String, posX: int, posY: int , idx:int): void {
	//s'instancia l'element corresponent
	addChild(element);
	element.name = nom+idx; //es construeix 
	element.x = posX;
	element.y = posY;
	
	//s'inclouen les posicions originals als arrays 'arrayPosicionsFinalsX' i 'arrayPosicionsFinalsY'
	arrayPosicionsFinalsX.push(posX);
	arrayPosicionsFinalsY.push(posY);

	element.addEventListener(MouseEvent.MOUSE_DOWN, arrossegarObjecte);
	element.addEventListener(MouseEvent.MOUSE_UP, alliberarObjecte);
	

};

//*** recuperarStringPosicionsElements => invocat per 'mostrarElements()' ***
//recull els valors de l'array 'posXY_elements'
//extreu el valor d'una posició random
//elimina l'índex per evitar duplicitats
function recuperarStringPosicionsElements(array: Array): String {
	var rnd: int = Math.floor(Math.random() * array.length);
	var currentString: String = array[rnd];
	array.removeAt(rnd);
	return currentString;
}

//DRAG
function arrossegarObjecte(e: MouseEvent): void {
	var obj = e.currentTarget;
	obj.startDrag(this);
	stage.addEventListener(MouseEvent.MOUSE_UP, alliberarObjecte);
	var topPosition: uint = this.numChildren - 1;
	this.setChildIndex(obj, topPosition);
}

//DROP
function alliberarObjecte(e: MouseEvent): void {
	var obj = e.currentTarget;
	var objName = obj.name.slice(0,-1); //retorna el nom sense l'índex
	var objIdx = obj.name.slice(-1); //retorna l'índex sense el nom => s'empra per accedir als arrays de posicions finals
	var droppedObjName = obj.dropTarget.parent.parent.name;
	
	obj.stopDrag();
	stage.removeEventListener(MouseEvent.MOUSE_UP, alliberarObjecte);

	if (objName == droppedObjName) {
		removeChild(obj);
	} else {
		obj.x = arrayPosicionsFinalsX[objIdx];
		obj.y = arrayPosicionsFinalsY[objIdx];
	};
}