﻿//*** triarElements() => invocat per 'stage'
//inicialitza l'array 'arrayElementsTriats', on cada posició guarda un dels elements triats per al joc.
//totes les funcions de renderització de la vista depenen directament o indirecta d'aquestes dades

function triarElements(): void {
	for (var i: int = 0; i < numElementsInteractius; i++) {
		var rnd: int = Math.floor(Math.random() * arrayElements.length);

		arrayElementsTriats.push(arrayElements[rnd]);
		arrayElementsTriats_aux.push(arrayElements[rnd]);

		arrayElements.removeAt(rnd);
	}
};

//*** triarIdentificadors() => invocat per 'stage'
//inicialitza l'array 'arrayIdentificadorsTriats', on cada posició guarda un dels identificadors triats per al joc.
//depén directament de 'arrayElementsTriats'
function triarIdentificadors(): void {
	for (var i: int = 0; i < numIdentificadors; i++) {
		var rnd: int = Math.floor(Math.random() * arrayElementsTriats_aux.length);

		arrayIdentificadorsTriats.push(arrayElementsTriats_aux[rnd]);

		arrayElementsTriats_aux.removeAt(rnd);
	}
};

//*** duplicar() => invocat per 'vista:mostrarElements()'
//crea una nova instància de l'element seleccionat
//afegeix a la nova instància els 'eventListener' corresponents
function duplicar(e:Event):void{
		var obj = e.currentTarget;
		
		var targetClass:Class;
		targetClass = Object(obj).constructor;

		var nouObj:DisplayObject = new targetClass();
		addChild(nouObj);
		
		nouObj.x = obj.x;
		nouObj.y = obj.y;
		nouObj.name = obj.name;
		
		nouObj.addEventListener(MouseEvent.MOUSE_MOVE, arrossegarObjecte);
		nouObj.addEventListener(MouseEvent.MOUSE_UP, alliberarObjecte);
}

//*** arrossegarObjecte() => invocat per 'controlador:duplicar()'
//defineix el comportament de l'objecte perquè sigui arrossegable
function arrossegarObjecte (e:MouseEvent) : void{
	if(casella_actual<limit){
		var obj = e.currentTarget;
		obj.startDrag(this);
		stage.addEventListener(MouseEvent.MOUSE_UP, alliberarObjecte);
	}
	else{
		eliminarComportament();
	}
}

//*** alliberarObjecte() => invocat per 'controlador:duplicar()' i 'controlador:arrossegarObjecte()'
//defineix el comportament de l'objecte quan deixa de ser arrossegat
function alliberarObjecte (e:MouseEvent) : void{
	var obj = e.currentTarget;
	var objName = obj.name;
	var posX = obj.x;
	var posY = obj.y;

	var droppedObj = obj.dropTarget.parent.parent;
	var casellaName : String = droppedObj.name.slice(0,-1); //retorna el nom de la casella sense l'índex => actua com a validador d'identificador
	var casellaIdx : int  = droppedObj.name.slice(-1); //retorna l'índex sense el nom de la casella=> actua com a validador de posició

	obj.stopDrag();

	if(objName === casellaName && casella_actual === casellaIdx){
		//crea una nova instància que queda fixada a la posició establerta de la sèrie
		var targetClass:Class;
			targetClass = Object(obj).constructor;
			var nouObj:DisplayObject = new targetClass();
			addChild(nouObj);
			nouObj.x = posX_elementsCorrectes;
			nouObj.y = posY_caselles;

		casella_actual++;
		posX_elementsCorrectes+=incX;
	}

	//s'elimina l'objecte arrossegable
	removeChild(obj);
	stage.removeEventListener(MouseEvent.MOUSE_UP, alliberarObjecte);
}

//
function eliminarComportament() : void {
	for(var i:int = 0 ; i<arrayElementsArrossegables.length ; i++){
		arrayElementsArrossegables[i].removeEventListener(MouseEvent.MOUSE_DOWN, duplicar);
	}
}

